// Definicija klase za nizove figura (Niz).

#ifndef _niz3_h_
#define _niz3_h_

#include "zbirka.h"

class Niz: public Zbirka {
  friend class N_iter;                         // Iterator za nizove.
  Figura** niz;                                // Elementi niza.
  int kap, duz;                                // Kapacitet i duina.
  void kopiraj(const Niz& n);                  // Kopiranje u niz.
  void premesti(Niz& n) {                      // Premetanje u niz.
    niz = n.niz; kap = n.kap; duz = n.duz;
    n.niz = nullptr;
  }
  void brisi() { ~*this; delete [] niz; }      // Oslobaanje memorije.
public:
  explicit Niz(int k=10)                       // Stvaranje praznog niza.
    { niz = new Figura* [kap = k]; duz = 0; }
  Niz(const Niz& n) { kopiraj(n); }            // Kopirajui konstruktor.
  Niz(Niz&& n) { premesti(n); }                // Premetajui konstruktor.
  ~Niz() { brisi(); }                          // Destruktor.
  Niz& operator=(const Niz& n) {               // Kopirajua dodela
    if (this != &n) { brisi(); kopiraj(n); }   //    vrednosti.
    return *this;
  }
  Niz& operator=(Niz&& n) {                   // Premetajua dodela
    if (this != &n) { brisi(); premesti(n); } //    vrednosti.
    return *this;
  }
  int vel() const { return duz; }              // Broj elemenata zbirke.
  Niz& operator+=(Figura* fig);                // Dodavanje figure.
  Niz& operator+=(const Figura& fig)
    { return *this += fig.kopija(); }
  Niz& operator+=(Figura&& fig)
    { return *this += move(fig).kopija(); }
  Figura*& operator[](int ind) {               // Dohvatanje figure.
    if (ind<0 || ind >= duz) greska(G_IND);
    return niz[ind];
  }
  const Figura* operator[](int ind) const
    { return const_cast<Niz&>(*this)[ind]; }
  Niz& operator~();                            // Pranjenje niza.
  Niz* kopija() const&                         // Stvaranje kopije niza.
    { return new Niz(*this); }
  Niz* kopija() &&
    { return new Niz(move(*this)); }
  Iter* iter();                                // Stvaranje iteratora.
  const Iter* iter() const;
};

#endif
