// Definicije metoda klase Tacka.

#include <cmath>
#include <iostream>
using namespace std;
#include "tacka1.h"

// Odstojanje tekue take od koordinatnog poetka.
double Tacka::poteg() const { return sqrt(x*x + y*y); }

// Nagib potega u odnosu na x-osu.
double Tacka::nagib() const { return (x==0 && y==0) ? 0 : atan2(y,x); }

// Odstojanje tekue take od take a.
double Tacka::rastojanje(Tacka a) const
  { return sqrt(pow(x-a.x,2) + pow(y-a.y,2)); }

// Najblia taka u nizu taaka a u odnosu na tekuu taku.
Tacka  Tacka::najbliza(const Tacka* a, int n) const {
  Tacka  t = a[0]; double r, m = rastojanje(t);
  for (int i=1; i<n; i++) if ((r=rastojanje(a[i]))<m) {m = r; t = a[i];}
  return t;
}

// itanje koordinata tekue take sa standardnog ulaza.
void  Tacka::citaj() { cin >> x >> y; }

// Pisanje koordinata tekue take na standardnom izlazu.
void  Tacka::pisi() const { cout << '(' << x << ',' << y << ')'; }
