// Klasa sa konstruktorima i destruktorom.

class Tekst {
  char* niz;                          // Pokazivac na sam tekst.
public:
  Tekst() { niz = nullptr; }         // Inicijalizacija prazne niske.
  Tekst(const char*);                // Inicijalizacija nizom znakova.
  Tekst(const Tekst&);               // Inicijalizacija kopiranjem Tekst-a.
  Tekst(Tekst&&);                    // Inicijalizacija pomeranjem Tekst-a.
  ~Tekst();                          // Unistavanje objekta tipa Tekst.
  void pisi() const;                 // Ispisivanje niske.
} ;

#include <cstring>
#include <iostream>
using namespace std;

Tekst::Tekst(const char* t)
  { niz = new char [strlen(t)+1]; strcpy(niz, t); }

Tekst::Tekst(const Tekst& t)
  { niz = new char [strlen(t.niz)+1]; strcpy(niz, t.niz); }
  
Tekst::Tekst(Tekst&& t) { niz = t.niz; t.niz = nullptr; }

Tekst::~Tekst() { delete [] niz; niz = nullptr; }

void Tekst::pisi() const { cout << niz; }

int main() {
  Tekst pozdrav("Pozdrav svima");    // Poziva se Tekst(char*).
  Tekst a = pozdrav;                 // Poziva se Tekst(Tekst&).
  Tekst b;                           // Poziva se Tekst().
  cout << "pozdrav = "; pozdrav.pisi(); cout << endl;
  cout << "a       = "; a.pisi ()      ; cout << endl;
} // Ovde se poziva destruktor za sva tri objekta.

