// Definicija apstraktne klase za zbirke figura (Zbirka).

#ifndef _zbirka_h_
#define _zbirka_h_

#include <iostream>
using namespace std;

#include "figura1.h"                          // Definicija klase Figura.
class Iter;                                   // Deklaracija klase Iter.

class Zbirka {
public:
  virtual ~Zbirka() {}                        // Virtuelan destruktor.
  virtual int vel() const =0;                 // Broj elemenata zbirke.
  virtual Zbirka& operator+=(Figura* fig)=0;  // Dodavanje figure.
  virtual Zbirka& operator+=(const Figura& fig) =0;
  virtual Zbirka& operator+=(Figura&& fig) =0;
  virtual Figura*& operator[](int ind) =0;    // Dohvatanje figure.
  virtual const Figura* operator[](int ind) const =0;
  virtual Zbirka& operator~() =0;             // Pranjenje zbirke.
  virtual Zbirka* kopija() const& =0;         // Stvaranje kopije zbirke.
  virtual Zbirka* kopija() && =0;
  friend ostream& operator<<                  // Pisanje zbirke.
    (ostream& it, const Zbirka& zb);

  virtual Iter* iter() =0;                    // Stvaranje iteratora.
  virtual const Iter* iter() const =0;

  enum { G_IND, G_TEK };                      // ifre greaka.
  [[noreturn]] static void greska(int g);     // Prekid programa.
};

#endif
